Package com.saxonica.ee.schema

## Class SchemaStructure

- java.lang.Object
- - com.saxonica.ee.schema.SchemaStructure

- All Implemented Interfaces:
    `javax.xml.transform.SourceLocator`, `Location`, `org.xml.sax.Locator`
  Direct Known Subclasses:
    `Assertion`, `AttributeDecl`, `AttributeGroupDecl`, `AttributeGroupReference`, `AttributeWildcard`, `ElementDecl`, `FieldOrSelector`, `IdentityConstraint`, `IdentityConstraintReference`, `ModelGroup`, `Notation`, `PreparedSchema`, `SimpleComponentReference`, `TypeAlternative`, `TypeReference`, `UserDefinedType`, `Wildcard`

      public abstract class SchemaStructure
      extends java.lang.Object
      implements Location

  The base class for all XML Schema stuctures. Generally represents a schema component in the sense of the XML Schema specification, though the correspondence is not always one to one. Maintains information about the location of the schema construct in an XML Schema document, for diagnostic purposes.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SchemaStructure()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `elaborate​(SchemaCompiler compiler)` | Elaborate the schema component: after reloading a serialized schema component model, this expands the component with derived information needed during validation episodes.
    `boolean` | `fixup​(SchemaCompiler compiler)` | Fixup references from this schema component to others
    `int` | `getColumnNumber()` | Get the column number of the element defining this schema component.
    `EnterpriseConfiguration` | `getConfiguration()` | Get the schema containing this structure
    `SchemaComponent.ValidationStatus` | `getFixupStatus()` | Get the current fixup status
    `java.lang.String` | `getGeneratedId()` | Get the generated ID, used to test whether two components are "identical"
    `int` | `getLineNumber()` | Get the line number of the element defining this schema component, within its module.
    `java.lang.String` | `getPublicId()` | Get the public ID of the containing module, if known.
    `int` | `getRedefinitionLevel()` | Get the redefinition level.
    `java.lang.String` | `getSchemaDocumentURI()` | Get the base URI of the containing xs:schema element.
    `java.lang.String` | `getSystemId()` | Get the system identifier (URI) of the schema module (XML document) containing the definition of this component.
    `SchemaComponent.ValidationStatus` | `getValidationStatus()` | Get the current validation status
    `boolean` | `hasSameLocation​(SchemaStructure other)` | Ask whether this schema component should be considered identical to another schema component
    `boolean` | `isValidationNeeded()` | Ask if validation is needed
    `void` | `lookForCycles​(java.util.Stack references, SchemaCompiler compiler)` | This method is called to look for cycles.
    `protected static Function` | `makeXPathExpressionPropertyRecord​(java.lang.String conditionText, NamespaceResolver nsResolver, java.lang.String baseURI)` | Helper method to make an XPathExpression property record
    `Location` | `saveLocation()` | Get an immutable copy of this Location object.
    `void` | `setConfiguration​(EnterpriseConfiguration config)` | Set the configuration containing this structure
    `void` | `setFixupStatus​(SchemaComponent.ValidationStatus status)` | Set the fixup status
    `void` | `setGeneratedId​(java.lang.String generatedId)` | Set the generated ID, used to test whether two components are "identical"
    `void` | `setLineNumber​(int lineNumber)` | Set the line number
    `void` | `setLocator​(javax.xml.transform.SourceLocator locator)` | Set the location information for this schema component.
    `void` | `setRedefinitionLevel​(int level)` | Set the redefinition level.
    `void` | `setSchemaDocumentURI​(java.lang.String uri)` | Set the base URI of the containing xs:schema element.
    `void` | `setSystemId​(java.lang.String systemId)` | Set the system Id
    `void` | `setValidationStatus​(SchemaComponent.ValidationStatus status)` | Set the validation status

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SchemaStructure

          public SchemaStructure()

  - ### Method Detail

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the system identifier (URI) of the schema module (XML document) containing the definition of this component.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the URI of the containing module.

    - #### getPublicId

          public java.lang.String getPublicId()

      Get the public ID of the containing module, if known.
      Specified by:
        `getPublicId` in interface `Location`
      Specified by:
        `getPublicId` in interface `org.xml.sax.Locator`
      Specified by:
        `getPublicId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        This information is not currently maintained, the method always returns null.

    - #### getLineNumber

          public int getLineNumber()

      Get the line number of the element defining this schema component, within its module. This will be as delivered by the SAX2 parser: that is, the line number of an element is generally the line number on which its start tag ends.
      Specified by:
        `getLineNumber` in interface `Location`
      Specified by:
        `getLineNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getLineNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the line number where the relevant element can be found.

    - #### getColumnNumber

          public int getColumnNumber()

      Get the column number of the element defining this schema component.
      Specified by:
        `getColumnNumber` in interface `Location`
      Specified by:
        `getColumnNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        -1: this information is not maintained.

    - #### saveLocation

          public Location saveLocation()

      Get an immutable copy of this Location object. By default Location objects may be mutable, so they should not be saved for later use. The result of this operation holds the same location information, but in an immutable form.
      Specified by:
        `saveLocation` in interface `Location`
      Returns:
        an immutable copy (which may be the original object, if it is already immutable)

    - #### setLocator

          public void setLocator​(javax.xml.transform.SourceLocator locator)

      Set the location information for this schema component.
      Parameters:
        `locator` - the location information.

    - #### setSystemId

          public void setSystemId​(java.lang.String systemId)

      Set the system Id
      Parameters:
        `systemId` - the systemId (the URI of the schema document in which the component is declared)

    - #### setLineNumber

          public void setLineNumber​(int lineNumber)

      Set the line number
      Parameters:
        `lineNumber` - the line number of the declaration of the component within its schema document

    - #### setSchemaDocumentURI

          public void setSchemaDocumentURI​(java.lang.String uri)

      Set the base URI of the containing xs:schema element. This will normally be the same as the systemId, unless the schema document is made up of multiple XML entities
      Parameters:
        `uri` - the base URI of the schema document

    - #### getSchemaDocumentURI

          public java.lang.String getSchemaDocumentURI()

      Get the base URI of the containing xs:schema element. This will normally be the same as the systemId, unless the schema document is made up of multiple XML entities
      Returns:
        the base URI of the containing schema document

    - #### setGeneratedId

          public void setGeneratedId​(java.lang.String generatedId)

      Set the generated ID, used to test whether two components are "identical"

    - #### getGeneratedId

          public java.lang.String getGeneratedId()

      Get the generated ID, used to test whether two components are "identical"
      Returns:
        the generated ID

    - #### getValidationStatus

          public SchemaComponent.ValidationStatus getValidationStatus()

      Get the current validation status
      Returns:
        an integer code indicating whether validation has not yet been started, is underway, has completed successfully, or has completed unsuccessfully

    - #### isValidationNeeded

          public boolean isValidationNeeded()

      Ask if validation is needed
      Returns:
        true if the component has not yet been validated

    - #### setValidationStatus

          public void setValidationStatus​(SchemaComponent.ValidationStatus status)

      Set the validation status
      Parameters:
        `status` - an integer code indicating whether validation has not yet been started, is underway, has completed successfully, or has completed unsuccessfully

    - #### getFixupStatus

          public SchemaComponent.ValidationStatus getFixupStatus()

      Get the current fixup status
      Returns:
        an integer code indicating whether fixup of component references has not yet been started, is underway, has completed successfully, or has completed unsuccessfully

    - #### setFixupStatus

          public void setFixupStatus​(SchemaComponent.ValidationStatus status)

      Set the fixup status
      Parameters:
        `status` - an integer code indicating whether fixup of component references has not yet been started, is underway, has completed successfully, or has completed unsuccessfully

    - #### setConfiguration

          public void setConfiguration​(EnterpriseConfiguration config)

      Set the configuration containing this structure
      Parameters:
        `config` - the Saxon configuration

    - #### getConfiguration

          public EnterpriseConfiguration getConfiguration()

      Get the schema containing this structure
      Returns:
        the Saxon configuration

    - #### setRedefinitionLevel

          public void setRedefinitionLevel​(int level)

      Set the redefinition level. This is zero for a component that has not been redefined; for a redefinition of a level-0 component, it is 1; for a redefinition of a level-N component, it is N+1. This concept is used to support the notion of "pervasive" redefinition: if a component is redefined at several levels, the top level wins, but it is an error to have two versions of the component at the same redefinition level.
      Parameters:
        `level` - the redefinition level

    - #### getRedefinitionLevel

          public int getRedefinitionLevel()

      Get the redefinition level. This is zero for a component that has not been redefined; for a redefinition of a level-0 component, it is 1; for a redefinition of a level-N component, it is N+1. This concept is used to support the notion of "pervasive" redefinition: if a component is redefined at several levels, the top level wins, but it is an error to have two versions of the component at the same redefinition level.
      Returns:
        the redefinition level

    - #### lookForCycles

          public void lookForCycles​(java.util.Stack references,
                                    SchemaCompiler compiler)
                             throws SchemaException

      This method is called to look for cycles. The object implementing this method is required (a) to raise an exception if the object itself appears in the list of references, (b) to add itself to the list of references, and (c) to call the lookForCycles method on all the objects that it references. This is a dummy implementation that does nothing; it must be overridden for components that can participate in cycles.
      Parameters:
        `references` - A stack of objects that contain direct or indirect references to this object, and that must therefore not be referred to from this object.
        `compiler` - the schema compiler
      Throws:
        `SchemaException` - if cycles are found

    - #### fixup

          public boolean fixup​(SchemaCompiler compiler)
                        throws SchemaException

      Fixup references from this schema component to others
      Parameters:
        `compiler` - the SchemaCompiler, used primarily for reporting errors
      Returns:
        true if all references were fixed up successfully, false if dangling references were found
      Throws:
        `SchemaException`

    - #### elaborate

          public void elaborate​(SchemaCompiler compiler)
                         throws SchemaException

      Elaborate the schema component: after reloading a serialized schema component model, this expands the component with derived information needed during validation episodes. The model is assumed to be valid.
      Parameters:
        `compiler` - the schema compiler
      Throws:
        `SchemaException`

    - #### makeXPathExpressionPropertyRecord

          protected static Function makeXPathExpressionPropertyRecord​(java.lang.String conditionText,
                                                                      NamespaceResolver nsResolver,
                                                                      java.lang.String baseURI)

      Helper method to make an XPathExpression property record

    - #### hasSameLocation

          public boolean hasSameLocation​(SchemaStructure other)

      Ask whether this schema component should be considered identical to another schema component
      Parameters:
        `other` - the other schema component
      Returns:
        true if (on balance of probabilities...) these two structures represent the same schema component. This is considered to be the case if they appear to derive from the same source declaration